#!/usr/bin/perl


##TODO: integrate this with grocess, replace s/<sc>// with regular expression with <sc\b[^>]*>(.*?)</sc>
##	ensure newline between each entry in main file
##	then start typesetting Psalms :)

use strict;
use IO::File;

my $GABCFILE = $ARGV[0];
my $GABCOUT = $GABCFILE;
my $TEXT;
my $KEEPSEARCHING = 1;
my $INLINE = "";
my $SCCOUNT = 0;
my $TXCOUNT = 0;

my $SCORENAME;

my $GABCFILES = $GABCFILE;
$GABCFILES =~ s/.gabc/-full.tex/;


## Remove previous temp file
system ("rm ./temp.tex");

## Create new temp file
my $TEMPFILE = "./temp.tex";

## insert headers to temp
open (OUTPUTTEMP,">>".$TEMPFILE);

## Read in the template
my @TEMPLATELINES;

@TEMPLATELINES = <DATA>;

## Name of the Score
open (GABC,"<".$GABCFILE) or die "No such file: $GABCFILE\n";
$INLINE = <GABC>;
if ($INLINE =~ /^name/) {
    $SCORENAME = $INLINE;
    $SCORENAME =~ s/^.*:\s*//;
    $SCORENAME =~ s/\s*;\s*$//;
}



&do_subst ("XXXX-GABCFILES-XXXX", $GABCFILES);
&do_subst ("XXXX-SCORENAME-XXXX", $SCORENAME);

## Create main wrapper
my $WRAPPER = $GABCFILE;
$WRAPPER =~ s/.gabc$/-main.tex/;

my $PDFOUTPUT = $WRAPPER;
$PDFOUTPUT =~ s/tex$/pdf/;

open (TEXWRAP,">".$WRAPPER) or die "Cannot write file $WRAPPER\n";
print TEXWRAP @TEMPLATELINES;
close (TEXWRAP);


## Split original gabc, add references in temp
open (GABC,"<".$GABCFILE) or die "No such file: $GABCFILE\n";
while ($KEEPSEARCHING == 1 && ($INLINE = <GABC>)) {
# if inline = tx or sc
  if ($INLINE =~ m/<sc>(.*?)<\/sc>/) {
  $TEXT = $INLINE;
  $TEXT =~ s/<sc>//;
  $TEXT =~ s/<\/sc>//;
  $SCCOUNT = $SCCOUNT + 1;
  $GABCOUT =~ s/.gabc$/$SCCOUNT.gabc/;
  print "$GABCOUT\n";
  print "$INLINE";
#  print "$SCCOUNT\n";
  open (OUTPUTTEMP,">>".$TEMPFILE);
  open (OUTPUT,">".$GABCOUT);
  print OUTPUT "name:;\n";
  print OUTPUT "centering-scheme:english;\n";
  print OUTPUT "%%\n";
  print OUTPUT "$TEXT";
  system ("gregorio $GABCOUT");
  $GABCOUT =~ s/.gabc$/.tex/;
#  print OUTPUTTEMP "\\noindent\n";
  print OUTPUTTEMP "\\includescore\{$GABCOUT\}\n";
  $INLINE =~ s/<sc>(.*?)<\/sc>//;
  close (OUTPUT);
  close (OUTPUTTEMP);

  $GABCOUT = $GABCFILE;

  }
if ($INLINE =~ m/<tx>(.*?)<\/tx>/) {
  $TEXT = $INLINE;
  $TEXT =~ s/<tx>//;
  $TEXT =~ s/<\/tx>//;
  open (OUTPUTTEMP,">>".$TEMPFILE);
  print OUTPUTTEMP "\\vspace{10pt}\\red{\\small $TEXT}\\par\n";
  $INLINE =~ s/<tx>(.*?)<\/tx>//;
  close (OUTPUTTEMP);


    }
#  if ($INLINE =~ /^%%/) { $KEEPSEARCHING = 0; }
}
system ("gprocess_lua $GABCFILE");

close (GABC);

open (TEXWRAP,">".$WRAPPER) or die "Cannot write file $WRAPPER\n";
print TEXWRAP @TEMPLATELINES;
close (TEXWRAP);

##Rename temp file

system("mv $TEMPFILE $GABCFILES");
system("lualatex $WRAPPER");
system("xpdf -g 900x550+0+275 -z 150 -cont $PDFOUTPUT");

## Make substitution in template
sub do_subst {
  my $TAG = $_[0];
  my $VAL = $_[1];

  foreach (@TEMPLATELINES) {
     s/$TAG/$VAL/g;
  }
};



#  THE LINES AFTER THIS "END" TAG ARE A TEMPLATE FOR THE TEX FILE TO BE GENERATED
__END__

\documentclass[12pt, letterpaper]{article}
\usepackage{fullpage}
\usepackage{palatino}
\usepackage{color}
\usepackage[T1]{fontenc}
\usepackage[utf8]{luainputenc}
\usepackage{gregoriotex}
%\usepackage{parskip}
%\usepackage{changemargin}
\pagestyle{empty}
\begin{document}
\newcommand{\red}[1]{\textcolor{red}{#1}}
\newcommand{\black}[1]{\textcolor{black}{#1}}

%\setspaceafterinitial{3.2mm plus 0em minus 0em}
%\setspacebeforeinitial{3.2mm plus 0em minus 0em}

\def\greinitialformat#1{%
{\fontsize{43}{43}\selectfont #1}%
}

\setgrefactor{17}
\grespaceabovelines=5mm

\begin{center}\begin{huge}\textsc{XXXX-SCORENAME-XXXX}\end{huge}\end{center}

\includescore{XXXX-GABCFILES-XXXX}

\end{document}


